diff --git a/tools/testing/selftests/mm/uffd-unit-tests.c b/tools/testing/selftests/mm/uffd-unit-tests.c
index 269c86768a02..3eb5a6f9b51f 100644
--- a/tools/testing/selftests/mm/uffd-unit-tests.c
+++ b/tools/testing/selftests/mm/uffd-unit-tests.c
@@ -881,13 +881,13 @@ static void retry_uffdio_zeropage(int ufd,
 	}
 }
 
-static bool do_uffdio_zeropage(int ufd, bool has_zeropage)
+static bool do_uffdio_zeropage(int ufd, bool has_zeropage, bool test_retry, unsigned long offset)
 {
 	struct uffdio_zeropage uffdio_zeropage = { 0 };
 	int ret;
 	__s64 res;
 
-	uffdio_zeropage.range.start = (unsigned long) area_dst;
+	uffdio_zeropage.range.start = (unsigned long) area_dst + offset;
 	uffdio_zeropage.range.len = page_size;
 	uffdio_zeropage.mode = 0;
 	ret = ioctl(ufd, UFFDIO_ZEROPAGE, &uffdio_zeropage);
@@ -901,7 +901,7 @@ static bool do_uffdio_zeropage(int ufd, bool has_zeropage)
 	} else if (has_zeropage) {
 		if (res != page_size)
 			err("UFFDIO_ZEROPAGE unexpected size");
-		else
+		else if (test_retry)
 			retry_uffdio_zeropage(ufd, &uffdio_zeropage);
 		return true;
 	} else
@@ -938,7 +938,7 @@ static void uffd_zeropage_test(uffd_test_args_t *args)
 		/* Ignore the retval; we already have it */
 		uffd_register_detect_zeropage(uffd, area_dst_alias, page_size);
 
-	if (do_uffdio_zeropage(uffd, has_zeropage))
+	if (do_uffdio_zeropage(uffd, has_zeropage, true, 0))
 		for (i = 0; i < page_size; i++)
 			if (area_dst[i] != 0)
 				err("data non-zero at offset %d\n", i);
@@ -952,6 +952,106 @@ static void uffd_zeropage_test(uffd_test_args_t *args)
 	uffd_test_pass();
 }
 
+static void do_uffdio_sigbus(int uffd, unsigned long offset)
+{
+	struct uffdio_sigbus uffdio_sigbus = { 0 };
+	int ret;
+	__s64 res;
+
+	uffdio_sigbus.range.start = (unsigned long) area_dst + offset;
+	uffdio_sigbus.range.len = page_size;
+	uffdio_sigbus.mode = 0;
+	ret = ioctl(uffd, UFFDIO_SIGBUS, &uffdio_sigbus);
+	res = uffdio_sigbus.updated;
+
+	if (ret)
+		err("UFFDIO_SIGBUS error: %"PRId64, (int64_t)res);
+	else if (res != page_size)
+		err("UFFDIO_SIGBUS unexpected size: %"PRId64, (int64_t)res);
+}
+
+static void uffd_sigbus_ioctl_handle_fault(
+	struct uffd_msg *msg, struct uffd_args *args)
+{
+	unsigned long offset;
+
+	if (msg->event != UFFD_EVENT_PAGEFAULT)
+		err("unexpected msg event %u", msg->event);
+
+	if (msg->arg.pagefault.flags &
+	    (UFFD_PAGEFAULT_FLAG_WP | UFFD_PAGEFAULT_FLAG_MINOR))
+		err("unexpected fault type %llu", msg->arg.pagefault.flags);
+
+	offset = (char *)(unsigned long)msg->arg.pagefault.address - area_dst;
+	offset &= ~(page_size-1);
+
+	/* Odd pages -> zeropage; even pages -> sigbus. */
+	if (offset & page_size) {
+		if (!do_uffdio_zeropage(uffd, true, false, offset))
+			err("UFFDIO_ZEROPAGE failed");
+	} else {
+		do_uffdio_sigbus(uffd, offset);
+	}
+}
+
+static void uffd_sigbus_ioctl_test(uffd_test_args_t *targs)
+{
+	pthread_t uffd_mon;
+	char c;
+	struct uffd_args args = { 0 };
+	struct sigaction act = { 0 };
+	unsigned long nr_sigbus = 0;
+	unsigned long nr;
+
+	fcntl(uffd, F_SETFL, uffd_flags | O_NONBLOCK);
+
+	if (!uffd_register_detect_zeropage(uffd, area_dst, nr_pages * page_size))
+		err("register failed: no zeropage support");
+
+	args.handle_fault = uffd_sigbus_ioctl_handle_fault;
+	if (pthread_create(&uffd_mon, NULL, uffd_poll_thread, &args))
+		err("uffd_poll_thread create");
+
+	sigbuf = &jbuf;
+	act.sa_sigaction = sighndl;
+	act.sa_flags = SA_SIGINFO;
+	if (sigaction(SIGBUS, &act, 0))
+		err("sigaction");
+
+	for (nr = 0; nr < nr_pages; ++nr) {
+		unsigned long offset = nr * page_size;
+		const char *bytes = (const char *) area_dst + offset;
+		const char *i;
+
+		if (sigsetjmp(*sigbuf, 1)) {
+			/*
+			 * Access below triggered a SIGBUS, which was caught by
+			 * sighndl, which then jumped here. Count this SIGBUS,
+			 * and move on to next page.
+			 */
+			++nr_sigbus;
+			continue;
+		}
+
+		for (i = bytes; i < bytes + page_size; ++i) {
+			if (*i)
+				err("nonzero byte in area_dst (%p) at %p: %u",
+				    area_dst, i, *i);
+		}
+	}
+
+	if (write(pipefd[1], &c, sizeof(c)) != sizeof(c))
+		err("pipe write");
+	if (pthread_join(uffd_mon, NULL))
+		err("pthread_join()");
+
+	if (nr_sigbus != nr_pages / 2)
+		err("expected to receive %lu SIGBUS, actually received %lu",
+		    nr_pages / 2, nr_sigbus);
+
+	uffd_test_pass();
+}
+
 /*
  * Test the returned uffdio_register.ioctls with different register modes.
  * Note that _UFFDIO_ZEROPAGE is tested separately in the zeropage test.
@@ -1127,6 +1227,12 @@ uffd_test_case_t uffd_tests[] = {
 		UFFD_FEATURE_PAGEFAULT_FLAG_WP |
 		UFFD_FEATURE_WP_HUGETLBFS_SHMEM,
 	},
+	{
+		.name = "sigbus-ioctl",
+		.uffd_fn = uffd_sigbus_ioctl_test,
+		.mem_targets = MEM_ALL & ~(MEM_HUGETLB | MEM_HUGETLB_PRIVATE),
+		.uffd_feature_required = UFFD_FEATURE_SIGBUS_IOCTL,
+	},
 };
 
 static void usage(const char *prog)